#***********************************************************************
#            Wort Uhr
#        ================
#        Uwe Berger; 2009
#
# Eine Tcl/Tk-Version.
#
#
# ---------
# Have fun!
#***********************************************************************

# Geometrie
set gvar(dx) 500
set gvar(dy) $gvar(dx)
set gvar(border) 5

set gvar(fontsize) [expr $gvar(dy)/10 - $gvar(border)]
set gvar(font) "Courier -$gvar(fontsize)"


# Farben
set gvar(colors) {gray20 white}

# interne Variablen
set gvar(old_m) 60

# Wort-Matrix
# -----------
# I T K I S G H A L F E   ==>  it_is half
# T E N Y Q U A R T E R   ==>  ten quarter
# D T W E N T Y F I V E   ==>  twenty|five
# T O P A S T E F O U R   ==>  to past four
# F I V E T W O N I N E   ==>  five two nine
# T H R E E T W E L V E   ==>  three twelve
# B E L E V E N O N E S   ==>  eleven one
# S E V E N W E I G H T   ==>  seven eight
# I T E N S I X T I E S   ==>  ten six
# T I N E O I C L O C K   ==>  o_clock

set letters {
			I T K I S G H A L F E\
			T E N Y Q U A R T E R\
			D T W E N T Y F I V E\
			T O P A S T E F O U R\
			F I V E T W O N I N E\
			T H R E E T W E L V E\
			B E L E V E N O N E S\
			S E V E N W E I G H T\
			I T E N S I X T I E S\
			T I N E O I C L O C K
			}
			
# Stunden-Tags (Offset, Lange)
set htxt {	{73 3} {48 3} {55 5} {40 4} {44 4} {92 3} 
			{77 5} {83 5} {51 4} {89 3} {67 6} {60 6}
		 }			
		 
# Wort-Tags (Offset, Laenge, Tag)
set words	{	{0 2 it_is}
				{3 2 it_is}
				{6 5 half}
				{11 3 ten}
				{15 7 quarter}
				{23 6 twenty}
				{29 4 five}
				{33 2 to}
				{35 4 past}
				{103 1 o_clock}
				{105 5 o_clock}
			}

#***********************************************************************
proc gui_init {} {
	global gvar letters htxt words
	wm title . "Wort Uhr" 
	wm resizable . 0 0
	canvas	.clock -width $gvar(dx) -height $gvar(dy) -bg black -bd 0
	pack .clock 
	# Buchstabenmatrix
	for {set j 0} {$j < 10} {incr j} {
		for {set i 0} {$i < 11} {incr i} {
			.clock create text \
								[expr $gvar(border)+$gvar(fontsize)/2+$i*($gvar(fontsize))] \
								[expr $gvar(border)+$gvar(fontsize)/2+$j*($gvar(fontsize))]\
								-text [lindex $letters [expr $j*11+$i]] \
								-font $gvar(font) \
								-fill [lindex $gvar(colors) 0]\
								-tags l[expr $j*11+$i]
		}
	}
	# Tags (neu) setzen
	# ... Stundentexte
	for {set h 0} {$h < 12} {incr h} {
		set pos [lindex [lindex $htxt $h] 0]
		set len [lindex [lindex $htxt $h] 1]
			for {set i $pos} {$i < [expr $pos + $len]} {incr i} {
			.clock itemconfigure l$i -tag h$h
		}
	}
	# ... anderer Text
	for {set w 0} {$w < 11} {incr w} {
		set pos [lindex [lindex $words $w] 0]
		set len [lindex [lindex $words $w] 1]
		set txt [lindex [lindex $words $w] 2]
			for {set i $pos} {$i < [expr $pos + $len]} {incr i} {
			.clock itemconfigure l$i -tag $txt
		}
	}
	# Zwischenminuten
	for {set i 0} {$i < 4} {incr i} {
		.clock create oval	[expr $gvar(border)+$gvar(fontsize)/2+$i*($gvar(fontsize))]\
							[expr $gvar(border)+$gvar(fontsize)/2+10*($gvar(fontsize))]\
							[expr $gvar(border)+$gvar(fontsize)/2+$i*($gvar(fontsize))+$gvar(border)]\
							[expr $gvar(border)+$gvar(fontsize)/2+10*($gvar(fontsize))+$gvar(border)]\
							-outline [lindex $gvar(colors) 0]\
							-fill [lindex $gvar(colors) 0]\
							-tags m$i
	}
	# AM/PM
	for {set i 0} {$i < 2} {incr i} {
		.clock create oval	[expr $gvar(border)+$gvar(fontsize)/2+($i+9)*($gvar(fontsize))]\
							[expr $gvar(border)+$gvar(fontsize)/2+10*($gvar(fontsize))]\
							[expr $gvar(border)+$gvar(fontsize)/2+($i+9)*($gvar(fontsize))+$gvar(border)]\
							[expr $gvar(border)+$gvar(fontsize)/2+10*($gvar(fontsize))+$gvar(border)]\
							-outline [lindex $gvar(colors) 0]\
							-fill [lindex $gvar(colors) 0]\
							-tags ap$i
	}
}

#****************************************************************************
proc takt {} {
	global gvar
	# Uhrzeit ermitteln
	set s [scan [clock format [clock seconds] -format %S] %d]
	set m [scan [clock format [clock seconds] -format %M] %d]
	set h [scan [clock format [clock seconds] -format %H] %d]
	# wenn Minute geaendert, dann Text neu schreiben...
	if {$gvar(old_m) != $m} {
		set gvar(old_m) $m
		# alles "ausschalten"
		.clock itemconfigure all -fill [lindex $gvar(colors) 0]
		# Texte ausgeben...
		# ... "it is"
		.clock itemconfigure it_is -fill [lindex $gvar(colors) 1]
		# ... "o clock"
		.clock itemconfigure o_clock -fill [lindex $gvar(colors) 1]
		# ... Minutentexte
		if {$m < 5} {
					# ...leer
		} elseif {$m < 10} {
					.clock itemconfigure five -fill [lindex $gvar(colors) 1]
					.clock itemconfigure past -fill [lindex $gvar(colors) 1]
		} elseif {$m < 15} {
					.clock itemconfigure ten -fill [lindex $gvar(colors) 1]
					.clock itemconfigure past -fill [lindex $gvar(colors) 1]
		} elseif {$m < 20} {
					.clock itemconfigure quarter -fill [lindex $gvar(colors) 1]
					.clock itemconfigure past -fill [lindex $gvar(colors) 1]
		} elseif {$m < 25} {
					.clock itemconfigure twenty -fill [lindex $gvar(colors) 1]
					.clock itemconfigure past -fill [lindex $gvar(colors) 1]
		} elseif {$m < 30} {
					.clock itemconfigure twenty -fill [lindex $gvar(colors) 1]
					.clock itemconfigure five -fill [lindex $gvar(colors) 1]
					.clock itemconfigure past -fill [lindex $gvar(colors) 1]
		} elseif {$m < 35} {
					.clock itemconfigure half -fill [lindex $gvar(colors) 1]
					.clock itemconfigure past -fill [lindex $gvar(colors) 1]
		} elseif {$m < 40} {
					.clock itemconfigure twenty -fill [lindex $gvar(colors) 1]
					.clock itemconfigure five -fill [lindex $gvar(colors) 1]
					.clock itemconfigure to -fill [lindex $gvar(colors) 1]
		} elseif {$m < 45} {
					.clock itemconfigure twenty -fill [lindex $gvar(colors) 1]
					.clock itemconfigure to -fill [lindex $gvar(colors) 1]
		} elseif {$m < 50} {
					.clock itemconfigure quarter -fill [lindex $gvar(colors) 1]
					.clock itemconfigure to -fill [lindex $gvar(colors) 1]
		} elseif {$m < 55} {
					.clock itemconfigure ten -fill [lindex $gvar(colors) 1]
					.clock itemconfigure to -fill [lindex $gvar(colors) 1]
		} elseif {$m <= 59} {
					.clock itemconfigure five -fill [lindex $gvar(colors) 1]
					.clock itemconfigure to -fill [lindex $gvar(colors) 1]
		}
		# Stundentext
		if {$h > 12} {set t_h [expr $h - 12]} else {set t_h $h}
		if {$m < 35} {
			if {$h == 0} {set t_h 12}
			.clock itemconfigure h[expr $t_h - 1] -fill [lindex $gvar(colors) 1]
		} else {
			if {$h == 12} {set t_h 0}
			.clock itemconfigure h$t_h -fill [lindex $gvar(colors) 1]
		}
		# Zwischenminuten ausgeben
		for {set i 0} {$i < 4} {incr i} {
			if {[expr $m % 5] > $i} {
				.clock itemconfigure m$i -fill [lindex $gvar(colors) 1];# -outline [lindex $gvar(colors) 1]
			}
		}
		# AM/PM bestimmen (funktioniert nur mit 24h-Zeitformaten!)
		if {$h >= 12} {
			.clock itemconfigure ap1 -fill [lindex $gvar(colors) 1];# -outline [lindex $gvar(colors) 1]
		} else {
			.clock itemconfigure ap0 -fill [lindex $gvar(colors) 1];# -outline [lindex $gvar(colors) 1]
		}
	}
	# eine Sekunde schlafen legen
	after 1000 takt
}

#****************************************************************************
#****************************************************************************
#****************************************************************************
gui_init
takt
