# Tk-Workshop CLT2011; Uwe Berger
#
# "kleiner Editor": Listbox, Scrollbar, Textbox
#

# Listbox mit Scrollbar definieren/anzeigen
scrollbar .sl -command ".l yview"
listbox .l -yscroll ".sl set" -width 20 -height 10
pack .l -side left -fill y -expand yes -fill both
pack .sl -side left -fill y
bind .l <Double-Button-1> {fill_textbox [selection get]}

# Textbox mit Scrollbar definieren/anzeigen
scrollbar .sty -command ".t yview"
text .t -width 50 -height 10 -yscrollcommand ".sty set" -wrap none
pack .t -side left -expand yes -fill both
pack .sty -side left -fill y

# alle .tcl-Dateinamen im aktuellen Verzeichnis in die Listbox
proc fill_listbox {} {
	foreach i [glob "*.tcl"] {
		.l insert end $i
	}
}

# Textbox fuellen
proc fill_textbox {f} {
	.t delete 1.0 end
	if {[file isfile $f]} {
		set fid [open $f "r"] 
		while {[gets $fid line] >= 0} {
       			.t insert end "$line\n"
		}
		close $fid
	}
}

fill_listbox
